Bug 252868 - Making graphics/blender depend on onetbb
Summary: Making graphics/blender depend on onetbb
Status: Closed FIXED
Alias: None
Product: Ports & Packages
Classification: Unclassified
Component: Individual Port(s) (show other bugs)
Version: Latest
Hardware: Any Any
: --- Affects Some People
Assignee: Ganael LAPLANCHE
URL:
Keywords:
Depends on: 252687 252785
Blocks: 252648
  Show dependency treegraph
 
Reported: 2021-01-20 20:58 UTC by Ganael LAPLANCHE
Modified: 2021-02-19 21:16 UTC (History)
1 user (show)

See Also:
FreeBSD: maintainer-feedback+
FreeBSD: maintainer-feedback+


Attachments
maintainer update for graphics/blender (8.89 KB, patch)
2021-01-27 05:53 UTC, Shane
FreeBSD: maintainer-approval+
Details | Diff

Note You need to log in before you can comment on or make changes to this bug.
Description Ganael LAPLANCHE freebsd_committer 2021-01-20 20:58:11 UTC
Hello,

As a maintainer of graphics/blender, could you have a look at PR #252648:

  https://bugs.freebsd.org/bugzilla/show_bug.cgi?id=252648

In short, TBB version 2021 will soon be available as devel/onetbb but the port you maintain does not build correctly with it, see the following Poudriere run:

  http://box.martymac.org/FreeBSD-Packages/build.html?mastername=FBSD122amd64-tbb-migr&build=2021-01-19_19h34m48s

and error logs:

http://box.martymac.org/FreeBSD-Packages/data/FBSD122amd64-tbb-migr/2021-01-19_19h34m48s/logs/errors/blender-2.91.0_3.log

c++ [...] /wrkdirs/usr/ports/graphics/blender/work/blender-2.91.0/intern/cycles/bvh/bvh.cpp
In file included from /wrkdirs/usr/ports/graphics/blender/work/blender-2.91.0/intern/cycles/bvh/bvh.cpp:25:
In file included from /wrkdirs/usr/ports/graphics/blender/work/blender-2.91.0/intern/cycles/bvh/../bvh/bvh_build.h:27:
In file included from /wrkdirs/usr/ports/graphics/blender/work/blender-2.91.0/intern/cycles/bvh/../util/util_task.h:22:
/wrkdirs/usr/ports/graphics/blender/work/blender-2.91.0/intern/cycles/bvh/../util/util_tbb.h:39:14: error: no member named 'self' in namespace 'tbb::v1::task'
  tbb::task::self().cancel_group_execution();
  ~~~~~~~~~~~^
1 error generated.
ninja: build stopped: subcommand failed.

Could you try to provide a patch (important: *by replying to this PR*) to facilitate the migration to devel/onetbb ?

To help you modifying your port, expected patches to devel/tbb and devel/onetbb are available in PR #252648.

You will also need:
- suitesparse patches from PR #252651
- opencv patches from PR #252785
- to disable option OPENVDB (see PR #252788)

Thanks for your contribution,
Best regards,

Ganael.
Comment 1 Ganael LAPLANCHE freebsd_committer 2021-01-20 21:04:37 UTC
Let me quote your feedback from PR #252687:

> I'm also the maintainer for blender. I'm starting to think that being able to
> co-install the old tbb will need to be an option for a while.

I would like to avoid that situation, as much as possible. That would mean relocate tbb to a dedicated subdir and patch every remaining dependent port.

> For blender, disabling tbb means disabling openvdb, openimagedenoise,
> mod_fluids and cycles. While the first two can be disabled for a while, I doubt 
> anyone will want blender without cycles. Blender is setup to disable those four
> options if using tbb is disabled and cycles doesn't compile without tbb.

It seems this is what we are seeing in the logs : cycles fail to compile. The upstream probably faces that exact same situation ; have you tried to ask for help from Blender community/devs ?

Thanks a lot,
Best regards,

Ganael.
Comment 2 Shane 2021-01-20 21:27:56 UTC
The last bug you added as depends is missing a digit.

About to test at a patch that is meant to fix the tbb build for blender.
Comment 3 Ganael LAPLANCHE freebsd_committer 2021-01-20 21:46:27 UTC
Fixed, thanks!

And good news for the patch :)
Comment 4 Shane 2021-01-27 05:53:32 UTC
Created attachment 221955 [details]
maintainer update for graphics/blender

Adjust graphics/blender to build with onetbb.
Disable OPENVDB and OPENIMAGEDN until dependencies transition to onetbb
New patches combine https://developer.blender.org/rB3732508 and https://developer.blender.org/rBa1f44e4
Comment 5 Ganael LAPLANCHE freebsd_committer 2021-01-27 17:21:25 UTC
Thanks a lot! I'll keep that patch for the big switch.
Comment 6 Ganael LAPLANCHE freebsd_committer 2021-02-19 21:16:52 UTC
Patch committed, thanks!